module Ohm
  module TTL
    def self.included(base)
      base.extend ClassMethods
    end

    module ClassMethods
      def it_is_high_noon ttl_key
        class_name, id = ttl_key.split('@')
        ohm_model = class_name.constantize rescue return
        if Ohm::Model === ohm_model.allocate
          ohm_model[id]&.delete
        end
      end
    end
    
    def ttl= sec
      Ohm.redis.call('setex', ttl_key, sec, true)
    end

    def ttl
      Ohm.redis.call('ttl', ttl_key)
    end

    def ttl_key
     raise RuntimeError.new('Id is nil, please save it first.') unless id
      "#{self.class.name}@#{id}"
    end
  end
end
